function Create(self)
	self.mapwrapx = SceneMan.SceneWrapsX;
	self.actionmode = 0;
	self.devicename = nil;
	self.deviceclass = nil;
	self.builddelay = nil;
	self.scantimer = Timer();
	self.buildtimer = Timer();
	self.tobuild = false;
	self.buildStarted = false;

	self.scandelay = 100;
	self.minbuilddelay = 3000;

end

function Update(self)

	if self.devicename ~= nil and self.buildelay ~= nil then
		if self.buildtimer:IsPastSimMS(self.builddelay) then
			self.Frame = 2;
		else
			self.Frame = 1;
		end
	else
		self.Frame = 0;
	end

	if self.scantimer:IsPastSimMS(self.scandelay) then
		self.scantimer:Reset();

		for item in MovableMan.Items do
			if SceneMan:ShortestDistance(self.Pos + Vector(-4,-13),item.Pos,self.mapwrapx).Magnitude < 12 then
				self.devicename = item.PresetName;
				self.deviceclass = item.ClassName;
				self.builddelay = item:GetTotalValue(0,0)*100;
				if self.builddelay < self.minbuilddelay then
					self.builddelay = self.minbuilddelay;
				end
				self.buildStarted = true;
				item.ToDelete = true;
				break;
			end
		end
		
		if self.buildStarted then

			self.part = nil;
			self.actor = nil;
			self.tobuild = false;
			
			if self.buildtimer:IsPastSimMS(self.builddelay) then
				self.moray = SceneMan:CastMORay(self.Pos,Vector(0,200),self.ID,-1,0,false,5);
				if self.moray ~= 255 then
					self.part = MovableMan:GetMOFromID(self.moray);
					self.actor = MovableMan:GetMOFromID(self.part.RootID);
					if MovableMan:IsActor(self.actor) then
						self.tobuild = true;
					end
				end
				if self.tobuild == true then
					self.buildtimer:Reset();
					if self.deviceclass == "HDFirearm" then
						self.product = CreateHDFirearm(self.devicename);
					elseif self.deviceclass == "TDExplosive" then
						self.product = CreateTDExplosive(self.devicename);
					elseif self.deviceclass == "HeldDevice" then
						self.product = CreateHeldDevice(self.devicename);
					end
					self.product.Pos = self.Pos + Vector(13,6):RadRotate(self.RotAngle);
					MovableMan:AddItem(self.product);
					self.product = nil;
				end
			end
		end

	end

end