function Create(self)
	self.mapwrapx = SceneMan.SceneWrapsX;
	self.actionmode = 0;
	self.objectname = nil;
	self.objectclass = nil;
	self.builddelay = nil;
	self.scantimer = Timer();
	self.buildtimer = Timer();
	self.tobuild = false;
	self.buildstarted = false;
	self.autobuild = false;
	self.canfire = true;
	self.canjump = true;
	self.inventorylistname = {};
	self.inventorylistclass = {};

	self.copyinventory = false;
	self.maxcopyitems = 15;
	self.scandelay = 100;
	self.minbuilddelay = 3000;
	self.entrypoint = Vector(8,-31);
	self.exitpoint = Vector(8,30);

end

function Update(self)

	self.HFlipped = false;
	self:GetController():SetState(Controller.MOVE_LEFT,false);
	self:GetController():SetState(Controller.MOVE_RIGHT,false);

	if self.objectname ~= nil then
		if self.tobuild == true then
			self.Frame = 1 + math.ceil((self.buildtimer.ElapsedSimTimeMS/self.builddelay)*4);
		elseif self.autobuild == true then
			self.Frame = 6 + math.ceil((self.buildtimer.ElapsedSimTimeMS/self.builddelay)*4);
		else
			self.Frame = 1;
		end
	else
		self.Frame = 0;
	end

	if self.scantimer:IsPastSimMS(self.scandelay) then
		self.scantimer:Reset();

		for item in MovableMan.Items do
			if SceneMan:ShortestDistance(self.Pos + Vector(self.entrypoint.X,self.entrypoint.Y):RadRotate(self.RotAngle),item.Pos,self.mapwrapx).Magnitude < item.Radius then
				self.objectname = item.PresetName;
				self.objectclass = item.ClassName;
				self.builddelay = item:GetGoldValue(0,0)*100;
				if self.builddelay < self.minbuilddelay then
					self.builddelay = self.minbuilddelay;
				end
				item.ToDelete = true;
				break;
			end
		end

		for actor in MovableMan.Actors do
			if actor.PresetName ~= self.PresetName and (actor.ClassName == "AHuman" or actor.ClassName == "ACrab") and SceneMan:ShortestDistance(self.Pos + Vector(self.entrypoint.X,self.entrypoint.Y):RadRotate(self.RotAngle),actor.Pos,self.mapwrapx).Magnitude < actor.Radius then
				self.objectname = actor.PresetName;
				self.objectclass = actor.ClassName;
				self.builddelay = actor:GetGoldValue(0,0)*100;
				self.buildstarted = true;
				if self.builddelay < self.minbuilddelay then
					self.builddelay = self.minbuilddelay;
				end
				if actor.ClassName == "AHuman" and self.copyinventory == true then

					self.inventorylistname = {};
					self.inventorylistclass = {};

					self.itemblocker = CreateTDExplosive("Stone","Ronin.rte");
					self.itemblocker.PresetName = "Nano Factory Blocker Rock";
					actor:AddInventoryItem(self.itemblocker);


					for i = 1, self.maxcopyitems do

						if i == 1 then
							for i = 1,MovableMan:GetMOIDCount()-1 do
								self.gun = MovableMan:GetMOFromID(i);
								if (self.gun.ClassName == "HDFirearm" or self.gun.ClassName == "TDExplosive" or self.gun.ClassName == "HeldDevice") and self.gun.RootID == actor.ID then
									self.inventorylistname[i] = self.gun.PresetName;
									self.inventorylistclass[i] = self.gun.ClassName;
									self.builddelay = self.builddelay + (self.gun:GetGoldValue(0,0) * 100);
								end
							end
						else

							self.potentialwep = actor:Inventory();
							if self.potentialwep ~= nil and self.potentialwep.PresetName ~= "Nano Factory Blocker Rock" then

								self.inventorylistname[i] = self.potentialwep.PresetName;
								self.inventorylistclass[i] = self.potentialwep.ClassName;
								self.builddelay = self.builddelay + (self.potentialwep:GetGoldValue(0,0) * 100);
								actor:SwapNextInventory(self.potentialwep,true);
							else
								break;
							end
						end
					end


				end
				actor.ToDelete = true;
				break;
			end
		end

	end

	if self.buildstarted then

		if self:IsPlayerControlled() == true then
			if self:GetController():IsState(Controller.WEAPON_FIRE) and self.canfire == true and self.autobuild == false then
				self.canfire = false;
				if self.tobuild == false then
					self.tobuild = true;
				else
					self.tobuild = false;
				end
				self.buildtimer:Reset();
			elseif not(self:GetController():IsState(Controller.WEAPON_FIRE)) then
				self.canfire = true;
			end

			if self:GetController():IsState(Controller.BODY_JUMP) and self.canjump == true then
				self.canjump = false;
				if self.tobuild == false then
					self.buildtimer:Reset();
				end
				if self.autobuild == false then
					self.autobuild = true;
				else
					self.autobuild = false;
				end
			elseif not(self:GetController():IsState(Controller.BODY_JUMP)) then
				self.canjump = true;
			end
		end

		if self.buildtimer:IsPastSimMS(self.builddelay) and (self.tobuild == true or self.autobuild == true) then

			self.buildtimer:Reset();
			self.tobuild = false;

			if self.objectclass == "HDFirearm" then
				self.product = CreateHDFirearm(self.objectname);
			elseif self.objectclass == "TDExplosive" then
				self.product = CreateTDExplosive(self.objectname);
			elseif self.objectclass == "HeldDevice" then
				self.product = CreateHeldDevice(self.objectname);
			elseif self.objectclass == "ACrab" then
				self.product = CreateACrab(self.objectname);
			elseif self.objectclass == "AHuman" then
				self.product = CreateAHuman(self.objectname);
				if self.copyinventory == true then
					for i = 1, #self.inventorylistname do
						if self.inventorylistclass[i] == "HDFirearm" then
							self.product:AddInventoryItem(CreateHDFirearm(self.inventorylistname[i]));
						elseif self.inventorylistclass[i] == "TDExplosive" then
							self.product:AddInventoryItem(CreateTDExplosive(self.inventorylistname[i]));
						elseif self.inventorylistclass[i] == "HeldDevice" then
							self.product:AddInventoryItem(CreateHeldDevice(self.inventorylistname[i]));
						end
					end
				end
			end
			self.product.Pos = self.Pos + Vector(self.exitpoint.X,self.exitpoint.Y+self.product.Radius):RadRotate(self.RotAngle);
			if self.product.ClassName == "ACrab" or self.product.ClassName == "AHuman" then
				self.product.Team = self.Team;
				self.product.AIMode = Actor.AIMODE_SENTRY;
				if self.AIMode == Actor.AIMODE_GOTO then
					self.waypoint = self:GetLastAIWaypoint();
					self.product:AddAISceneWaypoint(self.waypoint);
					self.product.AIMode = Actor.AIMODE_GOTO;
				end
				MovableMan:AddActor(self.product);
			else
				MovableMan:AddItem(self.product);
			end
			self.product = nil;
		end
	end

end